amaa/urls.py
from django.conf import settings
from django.conf.urls import include, url
from django.conf.urls.static import static
from django.contrib.staticfiles.views import serve

from .views import tasks as task_views

import session_csrf
session_csrf.monkeypatch()

from django.contrib import admin
admin.autodiscover()

urlpatterns = (
    # Examples:
    # url(r'^$', 'amaa.views.home', name='home'),
    # url(r'^blog/', include('blog.urls')),
    url(r'^_ah/', include('djangae.urls')),

    # Note that by default this is also locked down with login:admin in app.yaml
    url(r'^admin/', include(admin.site.urls)),

    url(r'^csp/', include('cspreports.urls')),

    url(r'^auth/', include('djangae.contrib.gauth.urls')),

    url(r'^_tasks/create-users/', task_views.create_users),

    url(r'^', include('dashboard.urls', namespace='dashboard')),
)

if settings.DEBUG:
    urlpatterns += tuple(static(settings.STATIC_URL, view=serve, show_indexes=True))

dashboard/urls.py
from django.conf.urls import url

from . import views


urlpatterns = [
    url(r'^big-screen/(?P<pk>\d+)/$', views.big_screen, name='big_screen'),
    url(r'^all-questions/$', views.all_questions, name='all_questions'),
    url(r'^session/(?P<pk>\d+)/$', views.question_list, name='question_list'),
    url(r'^finish-session/(?P<pk>\d+)/$', views.finish_session, name='finish_session'),
    url(r'^vote-question/(?P<pk>\d+)/$', views.vote_question, name='vote_question'),
    url(r'^$', views.session_list, name='session_list'),
]

dashboard/forms.py
from django import forms


class QuestionForm(forms.Form):
    question = forms.CharField(widget=forms.Textarea)

dashboard/views.py
# THIRD PARTY
from django.shortcuts import (
    get_object_or_404,
    redirect,
    render,
)
from django.core.urlresolvers import reverse

# AMAA
from amaa.models import QuestionSession, Question, Vote
from dashboard.forms import QuestionForm


def session_list(request):
    return render(request, template_name='dashboard/session_list.html', context={
        'question_session_list': QuestionSession.objects.all()
    })


def question_list(request, pk):
    question_session = get_object_or_404(QuestionSession, id=pk)

    if request.POST:
        form = QuestionForm(request.POST)

        if form.is_valid():
            Question.objects.create(
                session=question_session,
                text=form.cleaned_data['question'],
            )
            return redirect(reverse('dashboard:question_list', kwargs={'pk': question_session.pk}))
    else:
        form = QuestionForm()

    question_list = list(question_session.question_list.all())
    # Fetch all the corresponding Vote objects for the current user, if they haven't already been used
    question_pks = [q.pk for q in question_list]
    votes = list(request.user.vote_set.filter(question__pk__in=question_pks))
    can_vote_by_question = {vote.question_id: True for vote in votes}
    # Now assign a 'can vote' attribute to each question
    for question in question_list:
        question.can_vote = can_vote_by_question.get(question.pk, False)

    return render(request, template_name='dashboard/question_list.html', context={
        'question_session': question_session,
        'question_list': question_list,
        'form': form,
    })


def big_screen(request, pk):
    question_session = get_object_or_404(QuestionSession, id=pk)
    question_list = question_session.question_list.order_by("-votes_summed")
    context = {
        "question_session": question_session,
        "question_list": question_list,
    }
    return render(request, 'dashboard/big_screen.html', context)


def all_questions(request):
    return render(request, template_name='dashboard/all_questions.html', context={})


def vote_question(request, pk):
    question = get_object_or_404(Question, id=pk)
    if request.POST:
        vote = question.get_vote_for_user(request.user)
        if vote is not None:
            vote.vote()
    return redirect(reverse('dashboard:question_list', kwargs={'pk': question.session.id}))


def finish_session(request, pk):
    """ Allows the user to mark the session as finished, which removes it from the home page
        listing and deletes all of the Vote objects (leaving only the counts).
    """
    session = get_object_or_404(QuestionSession, pk=pk)
    context = {
        "question_session": session,
    }
    if request.method == "POST":
        session.is_finished = True
        session.save()
        session.wipeout()
        context["wipeout_started"] = True

    return render(request, "dashboard/finish_session.html", context)


def wipeout_voting_data(request):
    # This will allow you to call QuestionSession.wipeout() after a session is finished.
    # This might not be needed if we trigger it from the finish view.
    raise NotImplementedError

templates/dashboard/all_questions.html
{% extends 'dashboard/base.html' %}

{% block content %}
    <h1>All questions</h1>
{% endblock content %}

templates/dashboard/base.html
{% load staticfiles %}
<!doctype html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport"
          content="width=device-width, user-scalable=no, initial-scale=1.0, maximum-scale=1.0, minimum-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>AMAA</title>
    <link rel="stylesheet" href="{% static 'css/bootstrap.min.css' %}">
    <link rel="stylesheet" href="{% static 'css/amaa.css' %}">
</head>
<body>

    <div class="container">
        {% block content %}{% endblock content %}
    </div>

    <footer class="footer">
      {% block footer %}{% endblock %}
    </footer>

    <script src="{% static 'js/jquery.min.js' %}"></script>
    <script src="{% static 'js/tether.min.js' %}"></script>
    <script src="{% static 'js/bootstrap.min.js' %}"></script>
    <script src="{% static 'js/amaa.js' %}"></script>
</body>
</html>

templates/dashboard/big_screen.html
{% extends 'dashboard/base.html' %}

{% block content %}

      <h1>
        <small>AMA Anonymous</small><br/>
        {{ question_session.name }}
      </h1>

      <p class="top">
        Questions are now closed.
      </p>

            <ul class='qlist'>

                {% for question in question_list %}
                    <li class='q'>
                      <div class="question">{{ question.text }}</div>
                      <span class="vote selected">

                        <svg width="16px" height="14px" viewBox="0 0 16 14" version="1.1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink">
                            <defs></defs>
                            <g id="Symbols" stroke="none" stroke-width="1" fill="none" fill-rule="evenodd">
                                <g id="like-off" transform="translate(-10.000000, -5.000000)" fill-rule="nonzero">
                                    <g id="Group">
                                        <g class="thumbsup" transform="translate(10.000000, 5.000000)">
                                            <path class="thumb-shape" d="M0.666666667,14 L3.33333333,14 L3.33333333,6 L0.666666667,6 L0.666666667,14 Z M15.3333333,6.66666667 C15.3333333,5.93333333 14.7333333,5.33333333 14,5.33333333 L9.79333333,5.33333333 L10.4266667,2.28666667 L10.4466667,2.07333333 C10.4466667,1.8 10.3333333,1.54666667 10.1533333,1.36666667 L9.44666667,0.666666667 L5.06,5.06 C4.81333333,5.3 4.66666667,5.63333333 4.66666667,6 L4.66666667,12.6666667 C4.66666667,13.4 5.26666667,14 6,14 L12,14 C12.5533333,14 13.0266667,13.6666667 13.2266667,13.1866667 L15.24,8.48666667 C15.3,8.33333333 15.3333333,8.17333333 15.3333333,8 L15.3333333,6.72666667 L15.3266667,6.72 L15.3333333,6.66666667 Z" id="Shape"></path>
                                        </g>
                                    </g>
                                </g>
                            </g>
                        </svg>
                        <span class="count">
                          {{ question.votes_summed }}
                        </span>
                      </span>
                    </li>
                {% empty %}
                    <li>There were no questions.</li>
                {% endfor %}
            </ul>

{% endblock content %}

{% block footer %}
  <div class="container"><a href="{% url 'dashboard:finish_session' pk=question_session.pk %}">Finish Session</a></div>
{% endblock footer %}

templates/dashboard/finish_session.html
{% extends 'dashboard/base.html' %}

{% block content %}
    <h1>
        <small>AMA Anonymous</small><br/>
        Finish Session - {{ question_session.name }}
    </h1>

    {% if wipeout_started %}
        <div class="alert alert-success" role="alert">
            Session marked as finished.
        </div>
    {% else %}

        {% if question_session.is_finished %}
            <div class="alert alert-warning" role="alert">
            This session is already finished.
        </div>
        {% else %}
            <p>
                Are you sure you want to mark this session as done?
            </p>
            <p class="top">
                This will prevent any further voting and fully anonymise voting data.
            </p>
            <div class="alert alert-danger">
                This action cannot be undone.
            </div>

            <form action="" method="post">
                {% csrf_token %}
                <button type="submit" class="btn btn-primary">Finish Session</button>
            </form>
        {% endif %}
    {% endif %}


{% endblock content %}

templates/dashboard/question_list.html
{% extends 'dashboard/base.html' %}

{% block content %}
    <h1>
        <small>AMA Anonymous</small><br/>
        {{ question_session.name }}
    </h1>

    <p class="top">
        Check out the latest questions, or ask one yourself.
    </p>

    <ul class='qlist'>

        <li class="newq {% if form.question.errors %}open{% endif %}">
            <form action="" method="post">
                {% csrf_token %}
                <label for="id_question">Ask a new question</label>
                <button type="button" class='open-close'></button>
                <div class="newq-form">
                    <textarea class="form-control" name="question" id="id_question" rows="3"></textarea>
                    {% if form.question.errors %}
                        {% for error in form.question.errors %}
                        <div class="alert alert-danger" role="alert">{{ error }}</div>
                        {% endfor %}
                    {% endif %}
                    <button type="submit" class="btn btn-primary">Submit</button>
                </div>
            </form>
        </li>

        {% for question in question_list %}
            <li class='q'>
                <div class="question">{{ question.text }}</div>
                <form action="{% url 'dashboard:vote_question' question.id %}" method="post">
                    {% csrf_token %}
                    <button
                        class="vote {% if not question.can_vote %}selected{% endif %}"
                        {% if not question.can_vote %}disabled="disabled"{% endif %}
                    >
                        <svg width="16px" height="14px" viewBox="0 0 16 14" version="1.1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink">
                        <defs></defs>
                            <g id="Symbols" stroke="none" stroke-width="1" fill="none" fill-rule="evenodd">
                            <g id="like-off" transform="translate(-10.000000, -5.000000)" fill-rule="nonzero">
                            <g id="Group">
                            <g class="thumbsup" transform="translate(10.000000, 5.000000)">
                            <path class="thumb-shape" d="M0.666666667,14 L3.33333333,14 L3.33333333,6 L0.666666667,6 L0.666666667,14 Z M15.3333333,6.66666667 C15.3333333,5.93333333 14.7333333,5.33333333 14,5.33333333 L9.79333333,5.33333333 L10.4266667,2.28666667 L10.4466667,2.07333333 C10.4466667,1.8 10.3333333,1.54666667 10.1533333,1.36666667 L9.44666667,0.666666667 L5.06,5.06 C4.81333333,5.3 4.66666667,5.63333333 4.66666667,6 L4.66666667,12.6666667 C4.66666667,13.4 5.26666667,14 6,14 L12,14 C12.5533333,14 13.0266667,13.6666667 13.2266667,13.1866667 L15.24,8.48666667 C15.3,8.33333333 15.3333333,8.17333333 15.3333333,8 L15.3333333,6.72666667 L15.3266667,6.72 L15.3333333,6.66666667 Z" id="Shape"></path>
                            </g>
                            </g>
                            </g>
                            </g>
                        </svg>
                    </button>
                </form>
            </li>
            {% empty %}
            <li>There are no questions yet.</li>
        {% endfor %}
    </ul>
{% endblock content %}

templates/dashboard/session_list.html
{% extends 'dashboard/base.html' %}

{% block content %}
    <h1>Sessions</h1>

    <ul>
        {% for question_session in question_session_list %}
            <li class="session-list__session">
                <div class="session-detail">
                    <a href="{% url 'dashboard:question_list' question_session.pk %}">
                      <h3 class="title">
                        {{ question_session.name }}
                      </h3>
                    </a>
                </div>
                <div class="date">{{ question_session.time }}</div>
            </li>
        {% endfor %}
    </ul>
{% endblock content %}